=====================================================================
                            AScd Change Log
=====================================================================

------------- 09/05/99:

- updated to latest libworkman snapshot (1.4.2, 99/06/20)
- Themes doc updated

------------- 07/05/99:

- added panel_stop and panel_play options to Theme file format.

------------- 06/22/99:

- [fix] the track number is no longer drawn on every panel.
- [fix] the mute function called the fade-in one!

------------- 06/16/99:

- updated to latest libworkman snapshot (1.4.2, 99/05/29)

------------- 06/03/99:

- [fix] small redraw bugs that could cause "flashy" screen updates
- [fix] fade in/out mode was broken in previous 0.13.X.

------------- 05/25/99:

- new pixmap sliders. Currently only direct_access and volume are
  implemented, and only horizontal ones.

------------- 05/24/99:

- [fix] th_icon_window was not correctly set in fak_init_theme()

------------- 05/19/99:

- [fix] %s instead of %d in -debug theme summary
- added a -debug level

------------- 05/19/99: 0.13.1

- code cleanup
- a few changes in Imakefile
- more messages in -debug mode
- a couple of fixes

------------- 05/17/99: 0.13 *** beta stage ***

- [fix] horizontal volume bar bug

------------- 05/16/99:

- added "quick ref" support with quick_ref command and a button
  in the WINGs main window

------------- 05/16/99:

- added support for vertical sliders (CD direct access, volume and
  mixer) via vprogress_bar, vvolume_bar and vmixer_bar.
- added support for inverted vertical sliders via iprogress_bar,
  ivolume_bar and imixer_bar.
- mixer support (FreeBSD and Linux only. Please send me a mail if
  you compile mixer support on other platforms.)
- added -mixer commandline option to specify the mixer device
- themes manual updated
- man page updated
- reorganized the WINGs src files

------------- 05/13/99:

- [fix] Track name was not shown for track #1

------------- 05/11/99:

- better database support: CD default volume and CD autoplay are
  handled (CD autoplay if for WorkMan, AScd ignores this parameter)
- better WINGs handling. The WINGs window is no longer closed by
  the program when CD is ejected.
- [fix] WINGs windows crashed when CD was stopped
- [fix] big bug in database code that oftent crashed the
  program at startup time (cd_curtrack = -1)
- [fix] bug in the song title scrolling (hardcoded length)

------------- 05/11/99: 0.13pr6

- small updates in the man page (so outdated...)
- the theme manual (in PostScript) is now in the archive and
  installed in /usr/local/share/AScd
- added alt pixmap support for eject command
- added database panel which can now be different from message one
- changed the themes loading mechanism: themes are now installed in
  /usr/local/share/AScd/Themes. There's also a Default/ dir that can
  contain pixmaps. If a pixmap is not found in the theme dir, AScd
  also search in the Default dir. By default, this dir contains
  digits.xpm and digits2.xpm.
- the theme selectors now use dirent instead of the '.dir' file
- added alt pixmap support for mute command

------------- 05/10/99: 0.13pr5

- [fix] Less "floating point errors" should happen (I hope)
- [fix] the "°" in the counter was not drawn at the right place
- added icon keyword for a premilinary separate window/icon window
  handling. See sample themes!
- added no_icon_window and icon_window prologues keywords to use
  with big window themes (that cannot fit in the icon window)
- added volume slider handle with "volume" command
- [fix] bug in direct access bar handling

------------- 05/10/99: 0.13pr4

- [fix] string truncate when its length > message panel width
- added comment keyword in Theme files

------------- 05/09/99: 0.13pr3

New features and fixes since 0.12.1:

- |fix] ./configure didn't work when using an alt pixmap path
- [fix] a STOP order is sent to drive at the CD end (!autorepeat)
- changed the global redraw time offsets
- support for 8bit fonts
- added a line if WINGs "about" window
- added autoprobe mode, activated by default (+/-p cl option)
- [fix] crash at CD end on Linux systems

0.13 fixes and additions:

- added a second debug level
- the redraw routine has been redesigned. Screen updates should be
  less 'flashy' now...!

------------- 05/08/99: 0.13pr2

New features and fixes since 0.12.1:

- a few arrangements in the WINGs windows layout
- added a timeout for the theme and fast track selectors
- the fast track selector now scrolls the song titles
- support for loop clear and loop CD from start to current track
- mut be linked to 990505 LibWorkMan snapshot
- [fix] cd_control updated to 1.4 (added security in direct track)
- [fix] there was a bug in the cd_volume() calls in mute feature
- [fix] the messages now have priority on track title scrolling

0.13 fixes and additions:

- the buttons containing no command are no longuer parsed in
  case of mouse events
- support for introscan
- support for fade in/out
- support for theme selector
- support for fast track selector
- support for mute
- WINGs module works again, but the visual theme selector crashes :(

------------- 05/07/99: 0.13pr1 **** BACK TO ALPHA STAGE ****

It's the biggest change since I begun working on ascd. Everything
that appears on the screen is now 100% configurable. Put the buttons
you want, where you want!

- major rewrite of AScd. The source code has been splitted in
  several smaller C files.
- [bug] the WINGs support shall *not* compile. I didn't have time
  to update this code with the new features.
- added -debug cl option

All of the CD player commands are not yet available. Check the next
pre-releases.

------------- 05/06/99:

- [fix] redraw problem at CD's end when autorepeat is on.
- [fix] redraw problem when selecting "PLAY" with a stopped CD.

=====================================================================

------------- 05/02/99: 0.12.1

- [fix WINGs] the themes popup didn't display the selected theme
- multiple-mask shape mode, to allow transparent background with
  non rectangular buttons
- added a theme selector in the main window, activated by right
  clicking on the message line
- [fix] when a theme is not found, ascd try to use the default one
  instead of crashing.

------------- 04/19/99: 0.12.0 RELEASE

- added runtime visual themes management, with -theme cl option
- added a popup menu in configuration window to change the visual
  theme *without* restarting the program
- [fix] there was a bug in the mouse routine that could eject CD
  if the mouse click was outside the buttons
- [fix] a couple of typos in the WINGs windows.

=====================================================================

------------- 04/17/99: 0.11.2

- the volume is no longer set to the maximum at startup. AScd now
  uses libworkman to read the initial volume.
- [fix] clicking on "play" when CD was ejected crashed the program.
- [fix] changed the WMCreateButton calls (didn't compile with rh 5.2)
- added an #undef OSS_SUPPORT in libworkman's plat_linux.c
- again, small changes in libworkman's Config

------------- 04/15/99: "Le Chien"

- added "+/-ia" CL option to ignore avoid tags in WorkMan's database
- added a button in WINGs window to control this parameter
- cdcontrol updated to 1.3 release, with a few cleanups
- added "+/-up" CL option to force uppercase messages
- added a button in WINGs window to control this parameter
- removed the "counter" popup, replaced by radio buttons

------------- 04/14/99: 0.11.1

- added lowercase letters in (r)digits.xpm. I had to make a few
  changes in the background pixmap to display the new letters. I
  also added a conversion that remove accents.
- added 2 buttons in WINGs window to switch on/off song name and
  artist scrolling in main window.
- added a field to edit the cd device in WINGs window
- [fix] with a songname <= 8 cars, the artist was not shown
- [fix?] autorepeat

------------- 04/13/99: 0.11.0 RELEASE

- song title (and CD artist) display with scrolling
- added -showtitle and -showartist command line options
- in ejected mode, the "eject" button is replaced by the "quit" one
- [fix] redraw problems with panel switching when CD is ejected
- [cdcontrol] fix with track n# after eject/load
- AScd now supports WorkMan's "avoid track" parameter. It has a better
  handling than XfAScd: try it with Prince's "New Power Soul", when you
  have to skip tracks 11 to 48...
- the database edition fixed (didn't save!!!)

=====================================================================

------------- 04/12/99:

- added the "fast track selector" by clicking on the track number
  when playing. Click play button to play selected track.
- cdcontrol updated to version 1.2, fixing a bug in autoplay.
- [fix] event handling should be smoother (especialy mouse clicks)

------------- 04/10/99: "Human Being"

Well... Once again, the screen layout was redesigned. And the mixer
is gone again!

------------- 03/30/99:

- added -xf command line option
- first attempt to add database editing. Ugly!

------------- 03/19/99: (known as 0.10.1 RELEASE)

- added misc/default script to generate a default config.h file
  without asking any question.

=====================================================================

------------- 03/17/99: 0.10.0 RELEASE

- switched to current LibWorkMan, which is no longuer included in
  the archive.
- added a lot of settings in the WINGs window
- added a configure script
- updated cdcontrol to 1.0pre1
- changed the pixmaps selection
- code cleanup
- [fix] foreground color saving was buggy!
- [fix] the muted volume was not saved
- [fix] crashed at startup with no cd (WINGs option only)

=====================================================================

------------- 03/16/99: 0.9.4

- added the optionnal WINGs window with WorkMan database display,
  volume setting and autoplay/repeat switches. Still very
  experimental!
- the timer handling was redesigned and should be more efficient.
- added fade in/out functions (right button on play)
- better volume control, the min/max/current volume can be loaded and
  saved (~/.ascdrc)
- "-save" commandline option

------------- 03/01/99:

- "blind mode": in this mode, once a CD is started, AScd never
  updates the counter and never check the drive status.
- changed the idle timeout to 500 ms (as in future 1.0.)

------------- 02/26/99: 0.9.3

- [fix] autoplay fixes ("-1" track number at startup) (1.0 tree fix)
- [fix] pressing "eject" when the CD was already ejected crashed the
  program (1.0 tree fix)

------------- 02/10/99: 0.9.2 "p control"

* All:

- changed a few things in the Imakefiles. The "Config" file is now
  replaced by config.h, wish should be a little more simplier
- [fix] a few typos in docs, man page and program.

* Ascd:

- added the -mdevice command line option to specify the mixer device.
- the mixer_device is now saved/loaded in ~/.ascdrc
- [fix] if LEDs colors where defined in ~/.ascd, the commandline
  -bg and -fg didn't work -> "not enough color cells"
- [fix] when paused, selecting first or last track didn't work
- in mixer mode, the "track nbr" now displays the value for the
  current mixer slider
- added an alternate pixmap set, "fusion", which can be set in the
  config.h file.
- man page updated

------------- 01/28/99: 0.9.1 "Late at night"

* Ascd:

- [fix] 0.9 didn't compile if NO_D_DEVICE was defined. Thanks to
  Gus Hartmann who found the bug.
- [fix] 0.9 entered a crazy loop at CD end when autorepeat
  was off.

------------- 01/27/99: 0.9 RELEASE

* Ascd:

- code cleanup.

------------- 01/26/99: PR5 "If U need a fix..."

* Ascd:

- [fix] ascd crashed on launch with no cd in tray (since 01/22)
- [fix] up/down buttons didn't work when paused (since 01/22)
- [fix] track nbr was not properly redrawn when using up/down
  buttons when stopped (since 01/21)
- [fix] window was not properly redrawn when stopped (since 0.8-R)
- [fix] it was not possible to access the last track when stopped
- [fix] autorepeat works again (and fastly than in 0.8)
- the time display mode is now saved in ~/.ascdrc

* Lib:

- [BIG FIX] ascd now ejects CDs under FreeBSD. And there should be
  no more device locking (it was necessary to quit ascd to eject
  the CD and/or to mount a cdrom). Think this works with NetBSD too.
  (bug found in 0.4+, 0.6+, 0.7 & 0.8)

------------- 01/25/99: PR4 "If U need a mix..."

* Ascd:

- 100% new mixer section, with access to all the 17 mixing "sliders"
  of OSS.
- the back and foreground colors may now be different for the CD
  player and the mixer.
- all the mixer settings can be saved in a ~/.ascdrc file. This file
  can be loaded at startup.
- Total rewrite of the command line parse function. Added several
  new commands. See ascd -help for further details.

* Lib:

- [fix] I forgot to add the plat_openbsd.c in the Imakefile!
- added an option in the Config file to compile libworkman as a
  shared lib. Tested with FreeBSD 2.2.

------------- 01/22/99: PR3 "The Bug Factory"

* Ascd:

- Almost total rewrite of cd_control() function. The code should be
  more reliable (I hope!). Some clean-ups two.
- no more uses old ascd variables (currenttrack, maxtracks, playing,
  paused). Only the WorkMan ones (cur_track, cur_ntracks, cur_cdmode)
  are used.
- on launch, if autoplay is disabled, the track nbr panel displays
  how tracks are on the CD instead of "01".
- when the time panel displays the global remaining time of the CD,
  the track nbr panel displays the number of remaining tracks.
- new alpha pixmaps.
- adjusted timing for checking inserted CD in autoplay mode.
- Middle click on the display switch the mute mode. Muted/Unmuted
  volumes can be set with 'm' and 'v' command line parameters.
- [fix] in autoplay mode, launching ascd with an inserted audio CD in
  drive didn't play this one automatically.

------------- 01/21/99: PR2

* Ascd:

- The mixer code was removed once again, due to the big XPM code
  changes.
- XPM code redesigned: each button has its own XPM file.

------------- 01/14/99:

* Lib:

- added O_RDONLY | O_NONBLOCK flagsto the cd_device opening function
  in plat_linux.c and plat_freebsd.c. Thanks to Jens Axboe
  (axboe@image.dk)

------------- 12/20/98: PR1

* Lib:

- using WorkMan 1.3b (BETA) code instead of WorkMan 1.3a
- patched plat_freebsd.c to compile under FreeBSD 3.0. Thanks to
  Stephane Marzloff (secrer@le-bar.fdn.fr)
- plat_openbsd.c added (WorkMan)

=====================================================================

------------- 12/18/98: 0.8 RELEASE

* Lib:

- added plat_aix.c in lib dir. Thanks to Erik O'Shaughnessy
  (eriko@austin.ibm.com) who wrote this driver and sent it to me.

* Ascd:

- Pixmaps are back to 48x48 pixel size
- Small fixes in buttons pixmaps ; new digits pixmaps
- right click on STOP button kills app.
- mixer section is back again!
- man page updated.

------------- 12/07/98:

* Lib:

- srcs moved into subdirs, as PR1->PR4.
- Imakefiles are now working on Solaris. Makefile.solaris removed.
- WorkMan code is compiled as a library.

* Ascd:

- ascd now works with Solaris 7 i386 (gcc).

------------- 11/29/98:

- lib should now compile on Solaris 7 with gcc, using a specific
  Makefile.
- added NO_D_DEVICE option for Solaris Volume Manager.

------------- 12/01/97:

* Lib:

- [fix] it was impossible to play an inserted CD if autoplay mode was
  disabled.

------------- 09/25/97 -> 11/25/97:

* Lib:

- 'Config' file where all compilation options can be changed.
  can be changed.
- now recognize WorkMan splited tracks. Try it with Prince's
  Lovesexy's album !!

* Ascd:

- ascd now includes asmixer!
- added a "mixer screen" based on asmixer 0.5: clic on
  time display with right button to switch to it.
- added -v, -1, -2, -3 command line parameters for the
  mixer screen (same as asmixer). Removed the old -v option.
- setvol() and setvol_command() from asmixer src merged.
- added -t command line parameter: autorepeat
- stopped CD's display CD Length
- added "-b" command line option to specify the LEDs
  background color.
- changed "-l" option to "-f" ([F]oreground color)
- when CD is ejected, track nbr shows "--".
- all the XPMs are now included in ascd.c, to allow to
  define the bg color. I also fixed a few things in the
  "old and quick made" ascd+ buttons.
- when global time is displayed, clicking on the
  progress bar give access to the whole disk.
- added a "#define VERSION" in ascd.c
- added the new options (since 0.7) in the man page

=====================================================================

09/04/97: 0.7 release

(denis) based on 0.4+, but with the WindowMaker specific code taken
from ascd 0.6

- added: "-v" command line option to specify the volume to set
  when right-clicking on the time display.
- added: the time display now show a "-" before the remaining time(s)
  and a "o" if it displays the CD ellapsed/remaining time.
- added: folding tags in the ascd.c for the jed editor
- added: "-l" command line option to change the LEDs colour
- added: clicking on the "DOWN" button restart the track ; another
  click plays the previous track, like on a diskman (from Rob's
  ascd 0.6)
- fixed: redisplay of the XPMs was buggy with 0.4+ (but worked with
  afterstep... this fix is primary for WM)
- fixed: when autoplay is off, ascd doesn't scan the CD drive until
  you click on a button. No more thousands of "cannot read audio disk"
  in the FreeBSD logs :) (but there's still the problem with the "-a"
  option)

=====================================================================

v0.6
- Most important: WindowMaker Dock support with the -w flag!

=====================================================================

03/25/97: 0.4+ release

(denis) this is a bug-fixes release.

- fix: when first launch and if there was no CD in drive, a click on
  the play button crashed the program.
- fixed a "floating point exception" when the track progress bar is
  clicked on the very top.
- changed the "0.4" to "0.4+" for the "-h" option.

=====================================================================

03/23-24/97: 0.4+ release

(denis) Based on Rob Malda's ascd 0.4. All the Workbone Code has been
removed. I use the Workman source code: ascd can be compiled on
several systems with several kinds of CD players, but tests have been
made only on FreeBSD 2.2.X (i386) and Linux 2.X (i386) with IDE
drives. Should work with SCSI drives too. (note: I removed the Workman
database code)

- Imakefile has been updated for the Workman code.
- added: several new features (loops, introscan, progress bar...)
  (see the README file)
- changed the XPM files for the new buttons and the progress bar.
- added: 4th digit for songs longer than 10 minutes.
- added: -a command line option. Activates the autoplay mode: ascd
  automatically plays the CD when it is inserted.
- added: -c command line option which sets the value, in seconds,
  for the intro scan mode and the cue/review function.
- changed the indentation in the source code with the auto-
  indentation in jed. Sorry ;-)
- when a DATA CDROM is inserted, the display now show "--:--".
- a few fixes in ascd.c
- the default device is now /dev/cdrom.

=====================================================================

v0.4 - 1.15.96
- Thanks olly again (Does this guy sleep?) We have a few
  very nice bug fixes, and a nice new feature.
- ascd now stops correctly at the end of a CD.
- 'Next Track' used to go to far
- When ascd is paused, the LED now blinks!
- v0.4's secret code word is LLAMA BAIT

=====================================================================

v0.3 - 1.13.96
- Thanks to olly@muscat.co.uk, if a CD is playing when
  ascd launches, it detects this and starts following it.
- Thanks to the 9,000 of you who e-mailed me fixes (thanks
  guys, its nice to know people use this crap!) a Data CD
  will not crash ascd.
- About 15 people sent in CHEEZ DOODLE's to me.  Thanks.
  The code word for v0.3 is ORANGE NIPPLE.

=====================================================================

v0.2
- Fixed Certain Neat Error Messages
- I Think it should now get the last track from CD's.
- It shouldn't *lock* the CD Player from other devices
  once you press the 'stop' button.  This is especially
  useful with ascdc.
- Now includes the correct README file.  Thanks to the
  Hundreds of you who caught that.  It's nice to know
  someone reads these files.
